Subject: Re: [ippm] Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

From: "Frank Brockners (fbrockne)" <[email-masked]>
Date: Fri, 23 Apr 2021 18:25:01 +0000

Hi Francesca, Martin,

Sorry for the delayed response. Please see inline (…FB):

From: Francesca Palombini <[email-masked]>
Sent: Freitag, 26. März 2021 12:04
To: Martin Duke <[email-masked]>
Cc: The IESG <[email-masked]>; MORTON, ALFRED C (AL) <[email-masked]>; IPPM Chairs <[email-masked]>; [email-masked]; IETF IPPM WG <[email-masked]>
Subject: Re: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Hi Martin,

Yes, 5. In the COMMENT, about referencing normatively IEEE 15888. This was a “discuss” DISCUSS: as I said yesterday in the telechat, I do believe there is unfinished business about normatively referencing documents behind a paywall and wanted to bring this to the IESG attention, but I will not block the document because of it. I do think it is worth considering in this document if the normative reference is necessary, as it feels optional by context.

11. to me feels more important to fix. Also I did not include 8. In the DISCUSS part, but I’d really like a response to that one as well. The rest are less important – clarifications and points raised to make sure the WG had a discussion about them.

Francesca

From: Martin Duke <[email-masked]<mailto:[email-masked]>>
Date: Thursday, 25 March 2021 at 18:49
To: Francesca Palombini <[email-masked]<mailto:[email-masked]>>
Cc: The IESG <[email-masked]<mailto:[email-masked]>>, "MORTON, ALFRED C (AL)" <[email-masked]<mailto:[email-masked]>>, IPPM Chairs <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, IETF IPPM WG <[email-masked]<mailto:[email-masked]>>
Subject: Re: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Hi Francesca,

Which "Point 5" are you referring to in your DISCUSS? Is it the fifth item in your COMMENT?

On Wed, Mar 24, 2021 at 12:05 PM Francesca Palombini via Datatracker <[email-masked]<mailto:[email-masked]>> wrote:
Francesca Palombini has entered the following ballot position for
draft-ietf-ippm-ioam-data-12: Discuss

When responding, please keep the subject line intact and reply to all
email addresses included in the To and CC lines. (Feel free to cut this
introductory paragraph, however.)

Please refer to https://www.ietf.org/iesg/statement/discuss-criteria.html
for more information about IESG DISCUSS and COMMENT positions.

The document, along with other ballot positions, can be found here:
https://datatracker.ietf.org/doc/draft-ietf-ippm-ioam-data/

----------------------------------------------------------------------
DISCUSS:
----------------------------------------------------------------------

Thank you for this document. I think that the discussion on point 5. about
referencing normatively IEEE 1588, and 11. about IANA Expert guidelines are
worth having, and hope we can get them cleared before the document moves
forward. Also, please find some minor comments below.

Francesca

----------------------------------------------------------------------
COMMENT:
----------------------------------------------------------------------

1. -----

   document are to be interpreted as described in [RFC2119].

FP: Please update the boilerplate as per RFC 8147.
…FB: Thanks. We’ll fix this in the next revision.

2. -----

  The specification of how IOAM-Data-Fields
   are encapsulated into "parent" protocols, like e.g., NSH or IPv6 is
   outside the scope of this document.

FP: This sentence (or equivalent) appears several times - at least 2 times in
section 4 and once more in 5.1 - please consider removing the repetition.
…FB: Thanks. We’ll remove this repetition in the next revision.

3. -----

      For example, if 3 IOAM-Trace-Type bits are set and none of them
      are wide, then NodeLen would be 3.  If 3 IOAM-Trace-Type bits are

FP: As this is the first time the term "wide" appears, it would be good to
define it and add a reference. Alternatively, a sentence in the terminology
might have helped too.
…FB: The term “wide” is indeed confusing, given that it is used in section 5.4.1 before even the associated data types have been defined. Per your suggestion, we’ll add an explanation of the term, with reference to the associated data fields.

4. -----

      Bit 3    When set, indicates presence of timestamp subseconds in

FP: Same as for 3. - please add a reference to where "subsecond" is defined.
…FB: Another good catch. “Subseconds” are what other documents refer to as “fraction”. Would you be ok do a global “s/subsecond/fraction/” and refer to RFC8877?

5. -----

   formats; based on either PTP [IEEE1588v2], NTP [RFC5905], or POSIX
   [POSIX].  The three timestamp formats are specified in Section 6.  In

FP: Is the normative reference to IEEE 1588 (behind a paywall) absolutely
necessary? Rob Wilton pointed out that maybe a normative reference to RFC 8877
would be enough, however that would create a downref since 8877 is
informational. Also (minor) if kept, please consider updating to IEEE 1588-2019.
…FB: Rather than “referencing documents behind a paywall” as you say above, we can indeed use a reference to RFC 8877 instead. While it would formally be downref as you say, from a pure content perspective, we’d only leverage RFC 8877 in that it documents the PTP timestamp format.

6. -----

         computation, indicates which POT-profile is used.  The two
         profiles are numbered 0, 1.

FP: (just a comment) I found strange at this point that although two profiles
are mentioned, only one is defined in this document.
…FB: There might be a bit of a confusion here. Section 5.5.1 defines the IOAM Proof-of-Transit Option Type 0. The Option-Type differs from the POT-Profile. POT-Profiles are defined in draft-ietf-sfc-proof-of-transit. For the use of the POT-Profile flag, see e.g. section 5.1 in https://tools.ietf.org/html/draft-ietf-sfc-proof-of-transit-08 - the flag is used to flip between “even” and “odd” profiles.

7. -----

   Namespace-ID:  16-bit identifier of an IOAM-Namespace.  The

FP: Each option-type starts with Namespace-ID: couldn't this be optimized, or
what is the reasoning behind this?
…FB: Given all the other comments on IOAM namespaces, we’ll add some additional explanation of  the role of namespaces. The role of namespaces is to provide additional context to IOAM data fields - something that would be quite difficult to tie to a key which is likely going to be per node and potentially even per packet, depending on what scheme we'd use. The draft is pretty explicit about namespaces: “IOAM-Namespaces add further context to IOAM-Option-Types and associated IOAM-Data-Fields.".
Given that IOAM-Data-Fields are always interpreted the context of a specific namespace, the namespace field always needs to be carried along with the data-fields themselves.

8. -----

               IOAM domain.  Within the IOAM encapsulating node, the
               time that the timestamp is retrieved can depend on the
               implementation.  Some possibilities are: 1) the time at

   in one of three possible timestamp formats.  It is assumed that the
   management plane is responsible for determining which timestamp
   format is used.

FP: This is worrying for interoperability within different implementations.
Maybe more details or guidelines about how the management plane deals with this
(or references to relevant specification for which this is in scope) would help.
…FB: The main logic that IOAM follows is to keep the effort on network elements performing the packet forwarding to a minimum. I.e., have the network elements just gather the information – and perform translation/conversion of units on the network-management/analytics systems which would process the IOAM data. Given that there are different timestamp formats in use by different implementations, the operator can choose to use the timestamp format natively supported by the network element. Differentiation between different timestamp formats can easily be done by the use of proper associated namespace ids. Thus there wouldn’t be an interoperability issue. Different nodes would record the information in their preferred format – and the unit conversion would happen in the backend, which processes the data.

9. -----

   New registries in this group can be created via RFC Required process
   as per [RFC8126].

FP: (asking as this was not included in the shepherd review, and just want to
make sure this was addressed) For this and following registries: what is the
reasoning for not going for IETF Review?
…FB: Sorry, but I’m not entirely following. The suggestion is to follow the process defined in section 1.3 of RFC 8126 – assuming that the draft moves to RFC, and thus completes IETF review. Are you suggesting to follow a different process than what is stated in RFC 8126?

10. -----

   The meaning for Bits 1 - 7 are available for assignment via RFC
   Required process as per [RFC8126].

FP: From section 5.5 the bits 1-7 are indicated as Reserved.
…FB: Thanks. This is a really good catch. Section 5.5 shouldn’t list the fields as reserved. The next revision is going to correct that.

11. -----

   of the current document.  Registry entries for the values 0x8000 to
   0xFFFF are to be assigned via the "Expert Review" policy defined in
   [RFC8126].  Upon a new allocation request, the responsible AD will
   appoint a designated expert, who will review the allocation request.
   The expert will post the request on the mailing list of the IPPM
   working group in the IETF ([email-masked]<mailto:[email-masked]>), and possibly on other
   relevant mailing lists, to allow for community feedback.  Based on
   the review, the expert will either approve or deny the request.  The
   intention is that any allocation will be accompanied by a published
   RFC.  But in order to allow for the allocation of values prior to the
   RFC being approved for publication, the designated expert can approve
   allocations once it seems clear that an RFC will be published.

FP: The text above indicates Expert review for the registry. According to RFC
8126:

   The required documentation and review criteria, giving clear guidance
   to the designated expert, should be provided when defining the
   registry.  It is particularly important to lay out what should be
   considered when performing an evaluation and reasons for rejecting a
   request.

Although the paragraph above gives some indication of process for the experts,
it does not give clear review criteria or guidance. I would suggest this to be
expanded to give more indication to experts on what criteria to consider -
these same criteria will be considered by the working group as well.
…FB: Agreed. This can indeed be improved. Would Murray’s suggestion work for you? Murray suggested to include a template in the document, that a new registration would need to include. That way, it would be clear what data is expected to be provided – along with the criteria for acceptance.

Thanks much – and sorry again for the delay.
Cheers, Frank

---

From: "Frank Brockners (fbrockne)" <[email-masked]>
Date: Mon, 26 Apr 2021 08:12:14 +0000

Hi Francesca,

Another follow-up on your point 9. (new registries). Looks that I misread your comment: You were asking why the registry uses “RFC Required” (RFC 8126/section 4.7) and not “IETF Review”  ” (RFC 8126/section 4.8). I missed the “Review” word and got confused. TBH – given that current work, to define additional Flags, Option-Types, etc. are all following the “IETF Review” process already, i.e., there are working group drafts in IPPM for those, it would be very straight forward and even more natural to change to “IETF Review”. Given that you suggest the change, we’ll change to “IETF Review” in the next revision.

In addition – per what I already mentioned below, we’ll add templates per Murray’s suggestion. Suggested text:

IOAM Option-Type Registry

IOAM Option-Type Registry template. New registration requests MUST use the following template:

  Name:
     Name of the newly registered option type.

  Code point:
     Desired value of the requested code point.

  Description:
     Brief description of the newly registered option type.

  Reference
     Reference to the document that defines the new option type.

The templates for the other registries would look very similar. The only difference would be for the namespace registry.

IOAM Namespace-ID Registry

IOAM Namespace-ID Registry template. New registration requests MUST use the following
Template:

  Name:
     Name of the newly registered Namespace-ID.

  Code point:
     Desired value of the requested Namespace-ID.

  Description:
     Brief description of the newly registered Namespace-ID.

  Reference
     Reference to the document that defines the new option type.

  Status
     Status of the registration: Permanent or Provisional.
     Namespace-ID registrations following a successful expert review will have the status "provisional".
     Once the RFC, which defines the new Namespace-ID is published, the status is changed to "permanent".

Thoughts?

Thanks much, Frank

From: Frank Brockners (fbrockne) <[email-masked]>
Sent: Freitag, 23. April 2021 20:25
To: Francesca Palombini <[email-masked]>; Martin Duke <[email-masked]>
Cc: The IESG <[email-masked]>; MORTON, ALFRED C (AL) <[email-masked]>; IPPM Chairs <[email-masked]>; [email-masked]; IETF IPPM WG <[email-masked]>
Subject: RE: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Hi Francesca, Martin,

From: Francesca Palombini <[email-masked]<mailto:[email-masked]>>
Sent: Freitag, 26. März 2021 12:04
To: Martin Duke <[email-masked]<mailto:[email-masked]>>
Cc: The IESG <[email-masked]<mailto:[email-masked]>>; MORTON, ALFRED C (AL) <[email-masked]<mailto:[email-masked]>>; IPPM Chairs <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; IETF IPPM WG <[email-masked]<mailto:[email-masked]>>
Subject: Re: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Hi Martin,

Francesca

Hi Francesca,

Francesca

1. -----

2. -----

3. -----

4. -----

5. -----

6. -----

7. -----

8. -----

9. -----

10. -----

11. -----

---

From: Francesca Palombini <[email-masked]>
Date: Wed, 28 Apr 2021 12:48:41 +0000

Hi Frank! Thanks for the reply, and for addressing my comments.

Comments inline prefaced with [FP]. Your answers to those that I don’t comment inline look good to me.
As a summary, everything but the Expert guidelines comment (point 11.) is addressed.

Francesca

From: "Frank Brockners (fbrockne)" <[email-masked]>
Date: Monday, 26 April 2021 at 10:12
To: Francesca Palombini <[email-masked]>, Martin Duke <[email-masked]>
Cc: The IESG <[email-masked]>, "MORTON, ALFRED C (AL)" <[email-masked]>, IPPM Chairs <[email-masked]>, "[email-masked]" <[email-masked]>, IETF IPPM WG <[email-masked]>
Subject: RE: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Hi Francesca,

[FP] Yes, that’s why I brought this up, it seemed natural to have “IETF review” registration policy, and was wondering if there was any reasoning behind “RFC required” policy. I think it’s a good idea to change, thanks for taking this up.

  Name:

  Code point:

  Description:

  Reference

  Name:

  Code point:

  Description:

  Reference

  Status

Thoughts?

[FP] This is already better, thanks for taking this suggestion on. However, I still believe the document would be lacking Designated Expert guidelines. The type of guidelines I am thinking about is those that would help the expert decide if a registration should be accepted or not – is there anything important that the expert should think about? Anything that would help the expert evaluating the request? For ex, there could be some text about point squatting - making sure that the registration doesn’t duplicate an existing registration; or is the meaning that the DE is only there to forward requests to the mailing list? What if there is no answer from the working group, how does the DE evaluates the registration then? You have to consider that here you are providing any official text that the experts (which might need to change and could be someone with less experience) will look at and base their requests on.
I hope I clarified what I was looking for in this comment.

Thanks much, Frank

Hi Francesca, Martin,

Hi Martin,

Francesca

Hi Francesca,

Francesca

1. -----

2. -----

3. -----

4. -----

5. -----

[FP] This sounds good to me, thanks.

6. -----

FP: (just a comment) I found strange at this point that although two profiles
are mentioned, only one is defined in this document.
…FB: There might be a bit of a confusion here. Section 5.5.1 defines the IOAM Proof-of-Transit Option Type 0. The Option-Type differs from the POT-Profile. POT-Profiles are defined in draft-ietf-sfc-proof-of-transit. For the use of the POT-Profile flag, see e.g. section 5.1 in https://tools.ietf.org/html/draft-ietf-sfc-proof-of-transit-08 - the flag is used to flip between “even” and “odd” profiles.
[FP] Ah, I see, thanks for clarifying. Indeed, these are different things. If you think it would be helpful to readers, you could add a reference to sfc-proof-of-transit whenever you mention POT-Profile, to avoid any others getting confused (up to you though).

7. -----

[FP] I think this would help, thanks.

8. -----

[FP] Could you add this type of considerations to the text? This is what I was thinking when I talked about “guidelines”.

9. -----

[FP] Since this was taken up above, see my inline comment above.

10. -----

11. -----

[FP] Also replied above.

---

From: "Frank Brockners (fbrockne)" <[email-masked]>
Date: Wed, 28 Apr 2021 17:33:26 +0000

Hi Francesca,

Thanks a lot – your point below about the need to detail what the expert is supposed to do  / provide appropriate guidelines nails it and makes perfect sense.
We’ll try to come up with a paragraph for that in the next rev.

Thanks again, Frank

From: Francesca Palombini <[email-masked]>
Sent: Mittwoch, 28. April 2021 14:49
To: Frank Brockners (fbrockne) <[email-masked]>; Martin Duke <[email-masked]>
Cc: The IESG <[email-masked]>; MORTON, ALFRED C (AL) <[email-masked]>; IPPM Chairs <[email-masked]>; [email-masked]; IETF IPPM WG <[email-masked]>
Subject: Re: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Francesca

From: "Frank Brockners (fbrockne)" <[email-masked]<mailto:[email-masked]>>
Date: Monday, 26 April 2021 at 10:12
To: Francesca Palombini <[email-masked]<mailto:[email-masked]>>, Martin Duke <[email-masked]<mailto:[email-masked]>>
Cc: The IESG <[email-masked]<mailto:[email-masked]>>, "MORTON, ALFRED C (AL)" <[email-masked]<mailto:[email-masked]>>, IPPM Chairs <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, IETF IPPM WG <[email-masked]<mailto:[email-masked]>>
Subject: RE: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Hi Francesca,

  Name:

  Code point:

  Description:

  Reference

  Name:

  Code point:

  Description:

  Reference

  Status

Thoughts?

Thanks much, Frank

From: Frank Brockners (fbrockne) <[email-masked]<mailto:[email-masked]>>
Sent: Freitag, 23. April 2021 20:25
To: Francesca Palombini <[email-masked]<mailto:[email-masked]>>; Martin Duke <[email-masked]<mailto:[email-masked]>>
Cc: The IESG <[email-masked]<mailto:[email-masked]>>; MORTON, ALFRED C (AL) <[email-masked]<mailto:[email-masked]>>; IPPM Chairs <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; IETF IPPM WG <[email-masked]<mailto:[email-masked]>>
Subject: RE: Francesca Palombini's Discuss on draft-ietf-ippm-ioam-data-12: (with DISCUSS and COMMENT)

Hi Francesca, Martin,

Hi Martin,

Francesca

Hi Francesca,

Francesca

1. -----

2. -----

3. -----

4. -----

5. -----

6. -----

7. -----

8. -----

9. -----

10. -----

11. -----